part of '../../public.dart';

abstract class StatusModel<IdType> extends IdentityModel<IdType> {
  static const String statusTag = "status";
  final bool? status;

  const StatusModel({required super.id, this.status});
  StatusModel.fromMap(super.map)
      : status = map.getBool(statusTag),
        super.fromMap();

  @override
  Map<String, dynamic> toMap() => {...super.toMap(), statusTag: status};
}

extension StatusModelExtension<IdType, ModelType extends StatusModel<IdType>>
    on Iterable<ModelType> {
  ModelType? firstWhereByStatus(bool? status) =>
      firstWhereOrNull((element) => element.status == status);
  ModelType? lastWhereByStatus(bool? status) =>
      lastWhereOrNull((element) => element.status == status);

  Iterable<ModelType> whereByStatus(bool? status) =>
      where((element) => element.status == status);
}
