part of '../../../store_management.dart';

class ProductMeasureFilter extends TableFilter<ProductMeasureModel> {
  final InWhere<int>? productIds;
  final InWhere<int>? currencyIds;
  final InWhere<int>? measureUnitIds;
  final NumberRangeWhere<double>? price;
  final bool? status;
  final NumberRangeWhere<int>? parts;

  const ProductMeasureFilter({
    this.productIds,
    this.currencyIds,
    this.measureUnitIds,
    this.price,
    this.status,
    this.parts,
  });
  @override
  Map<String, dynamic> toMap() => {
        "productIds": productIds?.toMap(),
        "currencyIds": currencyIds?.toMap(),
        "measureUnitIds": measureUnitIds?.toMap(),
        "price": price?.toMap(),
        "status": status,
        "parts": parts?.toMap(),
      };

  @override
  bool check(ProductMeasureModel element) =>
      super.check(element) &&
      (productIds?.check(element.productId) ?? true) &&
      (currencyIds?.check(element.currencyId) ?? true) &&
      (measureUnitIds?.check(element.measureUnitId) ?? true) &&
      (price?.check(element.price) ?? true) &&
      (status == null || (status == element.status)) &&
      (parts?.check(element.parts ?? 0) ?? true);
}
