part of '../../../store_management.dart';

class ProductStorageFilter extends TableFilter<ProductStorageModel> {
  final InWhere<int>? productIds;
  final InWhere<int>? storeIds;
  final InWhere<int>? currencyIds;
  final InWhere<int>? measureUnitIds;
  final NumberRangeWhere<double>? price;
  final DateTimeRangeWhere? expiredAt;
  final NumberRangeWhere<int>? count;

  const ProductStorageFilter({
    this.productIds,
    this.storeIds,
    this.currencyIds,
    this.measureUnitIds,
    this.price,
    this.expiredAt,
    this.count,
  });
  @override
  Map<String, dynamic> toMap() => {
        "productIds": productIds?.toMap(),
        "storeIds": storeIds?.toMap(),
        "currencyIds": currencyIds?.toMap(),
        "measureUnitIds": measureUnitIds?.toMap(),
        "price": price?.toMap(),
        "expiredAt": expiredAt?.toMap(),
        "count": count?.toMap(),
      };

  @override
  bool check(ProductStorageModel element) =>
      super.check(element) &&
      (productIds?.check(element.productId) ?? true) &&
      (storeIds?.check(element.storeId) ?? true) &&
      (currencyIds?.check(element.currencyId) ?? true) &&
      (measureUnitIds?.check(element.measureUnitId) ?? true) &&
      (price?.check(element.price) ?? true) &&
      (expiredAt?.check(element.expiredAt) ?? true) &&
      (count?.check(element.count) ?? true);
}
